diff --git a/src/main/java/net/minecraft/core/block/DetectorRailBlock.java b/src/main/java/net/minecraft/core/block/DetectorRailBlock.java
index 37efefec6..4ca99be28 100644
--- a/src/main/java/net/minecraft/core/block/DetectorRailBlock.java
+++ b/src/main/java/net/minecraft/core/block/DetectorRailBlock.java
@@ -45,26 +45,26 @@ public class DetectorRailBlock extends RailBlock {
             return;
         }
         int meta = world.getBlockMetadata(x, y, z);
-        if ((meta & 8) != 0) { // If powered
+        if ((meta & MASK_POWERED) != 0) { // If powered
             checkForMinecart(world, x, y, z, meta);
         }
     }
 
     @Override
     public boolean getSignal(WorldSource worldSource, int x, int y, int z, Side side) {
-        return (worldSource.getBlockMetadata(x, y, z) & 0b1000) != 0;
+        return (worldSource.getBlockMetadata(x, y, z) & MASK_POWERED) != 0;
     }
 
     @Override
     public boolean getDirectSignal(World world, int x, int y, int z, Side side) {
-        if((world.getBlockMetadata(x, y, z) & 0b1000) == 0) {
+        if((world.getBlockMetadata(x, y, z) & MASK_POWERED) == 0) {
             return false;
         } else {
             return side == Side.TOP;
         }
     }
     private void checkForMinecart(World world, int x, int y, int z, int meta) {
-        boolean isPowered = (meta & 0b1000) != 0;
+        boolean isPowered = (meta & MASK_POWERED) != 0;
         boolean minecartPresent = false;
         float offset = 0.125f;
         List<Entity> list = world.getEntitiesWithinAABB(MinecartEntity.class, AABB.getTemporaryBB(x + offset, y + offset, z + offset, x + 1 - offset, y + 1 - offset, z + 1 - offset));
@@ -73,14 +73,14 @@ public class DetectorRailBlock extends RailBlock {
         }
         if(minecartPresent && !isPowered) {
             // Set rail to powered
-            world.setBlockMetadataWithNotify(x, y, z, meta | 0b1000);
+            world.setBlockMetadataWithNotify(x, y, z, meta | MASK_POWERED);
             world.notifyBlocksOfNeighborChange(x, y, z, id);
             world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
             world.markBlockDirty(x, y, z);
         }
         if(!minecartPresent && isPowered) {
             // Set rail to unpowered
-            world.setBlockMetadataWithNotify(x, y, z, meta & 0b111);
+            world.setBlockMetadataWithNotify(x, y, z, meta & ~MASK_POWERED);
             world.notifyBlocksOfNeighborChange(x, y, z, id);
             world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
             world.markBlockDirty(x, y, z);
diff --git a/src/main/java/net/minecraft/core/block/DoorBlock.java b/src/main/java/net/minecraft/core/block/DoorBlock.java
index a01317bed..2e635f4c8 100644
--- a/src/main/java/net/minecraft/core/block/DoorBlock.java
+++ b/src/main/java/net/minecraft/core/block/DoorBlock.java
@@ -4,7 +4,6 @@ import java.util.Random;
 import java.util.function.Supplier;
 
 import net.minecraft.core.block.entity.ActivatorBlockEntity;
-import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.DyeColor;
@@ -31,6 +30,9 @@ import org.jetbrains.annotations.Nullable;
 
 public class DoorBlock extends Block implements IPaintable
 {
+    public static final int MASK_ROTATION = 0b0000_0011;
+    public static final int MASK_OPENED = 0b0000_0100;
+    public static final int MASK_HINGE = 0b0000_1000; // 0 == left hinge; 1 == right hinge
 
 	public final boolean isTop;
 	public final boolean requireTool;
@@ -55,16 +57,16 @@ public class DoorBlock extends Block implements IPaintable
     }
 
     @Override
-    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
-        super.onBlockPlacedByMob(world, x, y, z, side, mob, sideHeight);
+    public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
+        super.onBlockPlacedOnSide(world, x, y, z, side, xPlaced, yPlaced);
 
         int meta = world.getBlockMetadata(x, y, z);
         if(world.hasNeighborSignal(x, y, z)) {
-            world.setBlockMetadataWithNotify(x, y, z, meta | 4);
+            world.setBlockMetadataWithNotify(x, y, z, meta | MASK_OPENED);
             if (isTop) {
-                world.setBlockMetadataWithNotify(x, y - 1, z, meta | 4);
+                world.setBlockMetadataWithNotify(x, y - 1, z, meta | MASK_OPENED);
             } else {
-                world.setBlockMetadataWithNotify(x, y + 1, z, meta | 4);
+                world.setBlockMetadataWithNotify(x, y + 1, z, meta | MASK_OPENED);
             }
         }
     }
@@ -84,7 +86,7 @@ public class DoorBlock extends Block implements IPaintable
     @Override
     public AABB getSelectedBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
-        setDoorRotation(getState(world.getBlockMetadata(x, y, z)), true);
+        setBoundsForRotation(getRotation(world.getBlockMetadata(x, y, z)), true);
         return super.getSelectedBoundingBoxFromPool(world, x, y, z);
     }
 
@@ -98,10 +100,10 @@ public class DoorBlock extends Block implements IPaintable
     @Override
     public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
     {
-        setDoorRotation(getState(world.getBlockMetadata(x, y, z)), false);
+        setBoundsForRotation(getRotation(world.getBlockMetadata(x, y, z)), false);
     }
 
-    public void setDoorRotation(int i, boolean drawingSelection)
+    public void setBoundsForRotation(int rotation, boolean drawingSelection)
     {
         float top = 1.0f, bottom = 0.0f;
         if (isTop && drawingSelection)
@@ -116,19 +118,19 @@ public class DoorBlock extends Block implements IPaintable
         }
         float f = 0.1875F;
         setBlockBounds(0.0F, bottom, 0.0F, 1.0F, top, 1.0F);
-        if(i == 0)
+        if(rotation == 0)
         {
             setBlockBounds(0.0F, bottom, 0.0F, 1.0F, top, f);
         }
-        if(i == 1)
+        if(rotation == 1)
         {
             setBlockBounds(1.0F - f, bottom, 0.0F, 1.0F, top, 1.0F);
         }
-        if(i == 2)
+        if(rotation == 2)
         {
             setBlockBounds(0.0F, bottom, 1.0F - f, 1.0F, top, 1.0F);
         }
-        if(i == 3)
+        if(rotation == 3)
         {
             setBlockBounds(0.0F, bottom, 0.0F, f, top, 1.0F);
         }
@@ -142,7 +144,7 @@ public class DoorBlock extends Block implements IPaintable
     }
 
     @Override
-    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, @Nullable Player player, Side side, double xPlaced, double yPlaced)
     {
         if(blockMaterial == Material.metal)
         {
@@ -159,9 +161,9 @@ public class DoorBlock extends Block implements IPaintable
         }
         if(Block.blocksList[world.getBlockId(x, y + 1, z)] instanceof DoorBlock)
         {
-            world.setBlockMetadataWithNotify(x, y + 1, z, l ^ 4);
+            world.setBlockMetadataWithNotify(x, y + 1, z, l ^ MASK_OPENED);
         }
-        world.setBlockMetadataWithNotify(x, y, z, l ^ 4);
+        world.setBlockMetadataWithNotify(x, y, z, l ^ MASK_OPENED);
         world.markBlocksDirty(x, y - 1, z, x, y, z);
         world.playBlockEvent(player, LevelListener.EVENT_DOOR_SOUND, x, y, z, 0);
         return true;
@@ -174,9 +176,9 @@ public class DoorBlock extends Block implements IPaintable
 
     public void onPoweredBlockChange(World world, int x, int y, int z, boolean isPowered)
     {
-        int l = world.getBlockMetadata(x, y, z);
+        int meta = world.getBlockMetadata(x, y, z);
         
-        if ((l & 0x8) > 0) isPowered = !isPowered;
+        if ((meta & MASK_HINGE) > 0) isPowered = !isPowered;
         
         if(isTop)
         {
@@ -193,11 +195,11 @@ public class DoorBlock extends Block implements IPaintable
         }
         if(Block.blocksList[world.getBlockId(x, y + 1, z)] instanceof DoorBlock)
         {
-            world.setBlockMetadataWithNotify(x, y + 1, z, l ^ 4);
+            world.setBlockMetadataWithNotify(x, y + 1, z, meta ^ MASK_OPENED);
         }
-        world.setBlockMetadataWithNotify(x, y, z, l ^ 4);
+        world.setBlockMetadataWithNotify(x, y, z, meta ^ MASK_OPENED);
         world.markBlocksDirty(x, y - 1, z, x, y, z);
-        world.playBlockEvent(null, 1003, x, y, z, 0);
+        world.playBlockEvent(null, LevelListener.EVENT_DOOR_SOUND, x, y, z, 0);
     }
 
     @Override
@@ -290,21 +292,19 @@ public class DoorBlock extends Block implements IPaintable
         return super.collisionRayTrace(world, x, y, z, start, end);
     }
 
-    public int getState(int i)
+    public int getRotation(int i)
     {
-        if((i & 4) == 0)
-        {
-            return i - 1 & 3;
-        } else
-        {
-            return i & 3;
+        if ((i & MASK_OPENED) != 0) {
+            return i & MASK_ROTATION;
+        } else {
+            return (i - 1) & MASK_ROTATION;
         }
     }
 
     public static boolean isOpen(int i)
     {
-    	boolean hasRightHinge = (i & 8) != 0;
-    	boolean opened = (i & 4) != 0; 
+    	boolean hasRightHinge = (i & MASK_HINGE) != 0;
+    	boolean opened = (i & MASK_OPENED) != 0;
     	
         return !hasRightHinge && opened || hasRightHinge && !opened;
     }
@@ -324,7 +324,7 @@ public class DoorBlock extends Block implements IPaintable
     @Override
     public int getPistonPushReaction(World world, int x, int y, int z)
     {
-        return 1;
+        return Material.PISTON_DESTROY_ON_PUSH;
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/block/FarmlandBlock.java b/src/main/java/net/minecraft/core/block/FarmlandBlock.java
index 29085bf58..ba3fb8f88 100644
--- a/src/main/java/net/minecraft/core/block/FarmlandBlock.java
+++ b/src/main/java/net/minecraft/core/block/FarmlandBlock.java
@@ -6,6 +6,7 @@ import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.IArmorItem;
 import net.minecraft.core.item.IBonemealable;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
@@ -19,6 +20,8 @@ import java.util.Random;
 
 public class FarmlandBlock extends Block implements IBonemealable
 {
+	public static final int MASK_FERTILIZED = 0b0001_0000;
+	public static final int MASK_WET = 0b0000_1111;
 	public FarmlandBlock(String key, String namespaceId, int id)
 	{
 		super(key, namespaceId, id, Material.dirt);
@@ -28,26 +31,33 @@ public class FarmlandBlock extends Block implements IBonemealable
 	}
 
 	public static boolean isWet(int data) {
-		return (data & 0x0F) > 0;
+		return getWet(data) > 0;
+	}
+
+	public static int getWet(int data) {
+		return (data & MASK_WET);
 	}
 
 	public static int setWet(int data, int amount) {
-		return (amount & 0x0F) | (data & 0xF0);
+		return (amount & MASK_WET) | (data & ~MASK_WET);
 	}
 
 	public static boolean isFertilized(int data) {
-		return (data & 0x10) > 0;
+		return (data & MASK_FERTILIZED) != 0;
 	}
 
 	public static int setFertilized(int data, boolean fertilized) {
-		int f = fertilized ? 0x10 : 0x00;
-		return (data & 0x0F) | f;
+		if (fertilized) {
+			return data | MASK_FERTILIZED;
+		} else {
+			return data & ~MASK_FERTILIZED;
+		}
 	}
 
 	@Override
 	public AABB getCollisionBoundingBoxFromPool(final WorldSource world, final int x, final int y, final int z)
 	{
-		return AABB.getTemporaryBB(x + 0, y + 0, z + 0, x + 1, y + 1, z + 1);
+		return AABB.getTemporaryBB(x, y, z, x + 1, y + 1, z + 1);
 	}
 
 	@Override
@@ -130,7 +140,7 @@ public class FarmlandBlock extends Block implements IBonemealable
 		{
 			if (entity instanceof Player)
 			{
-				if (((Player) entity).inventory.armorInventory[0] != null && ((Player) entity).inventory.armorInventory[0].getItem() == Items.ARMOR_BOOTS_LEATHER) {
+				if (((Player) entity).inventory.armorInventory[IArmorItem.PIECE_BOOTS] != null && ((Player) entity).inventory.armorInventory[IArmorItem.PIECE_BOOTS].getItem() == Items.ARMOR_BOOTS_LEATHER) {
 					return;
 				}
 				if(isWet(world.getBlockMetadata(x, y, z)))
@@ -168,11 +178,10 @@ public class FarmlandBlock extends Block implements IBonemealable
 		if (rand.nextInt(5) == 0) {
 			int data = world.getBlockMetadata(x, y, z);
 			if (isWaterNearby(world, x, y, z) || world.canBlockBeRainedOn(x, y + 1, z)) {
-				world.setBlockMetadataWithNotify(x, y, z, data | 7);
+				world.setBlockMetadataWithNotify(x, y, z, setWet(data, getWet(data) - 1));
 			} else {
 				if (isWet(data)) {
-					int newData = ((data & 0x0F) - 1) | (data & 0xF0);
-					world.setBlockMetadataWithNotify(x, y, z, newData);
+					world.setBlockMetadataWithNotify(x, y, z, setWet(data, 0));
 				} else if (!isCropsNearby(world, x, y, z)) {
 					world.setBlockWithNotify(x, y, z, Blocks.DIRT.id);
 				}
diff --git a/src/main/java/net/minecraft/core/block/FenceGateBlock.java b/src/main/java/net/minecraft/core/block/FenceGateBlock.java
index 8630ba6e4..6c0f4e947 100644
--- a/src/main/java/net/minecraft/core/block/FenceGateBlock.java
+++ b/src/main/java/net/minecraft/core/block/FenceGateBlock.java
@@ -19,6 +19,8 @@ import org.jetbrains.annotations.Nullable;
 
 public class FenceGateBlock extends Block implements IPaintable
 {
+    public static final int MASK_DIRECTION = 0b0000_0011;
+    public static final int MASK_OPEN = 0b0000_0100;
 
     public FenceGateBlock(String key, String namespaceId, int id)
     {
@@ -29,7 +31,7 @@ public class FenceGateBlock extends Block implements IPaintable
 	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
         int l = world.getBlockMetadata(x, y, z);
-        if(func_35291_d(l))
+        if(isOpen(l))
         {
             return null;
         } else
@@ -40,7 +42,7 @@ public class FenceGateBlock extends Block implements IPaintable
     
     private AABB getAABBFromMeta(int meta)
     {
-    	if (func_35290_f(meta) == 3 || func_35290_f(meta) == 1)
+    	if (getDirection(meta) == 3 || getDirection(meta) == 1)
     	{
     		return AABB.getTemporaryBB(0.375f, 0, 0, 1 - 0.375f, 1.0F, 1f);
     	}
@@ -83,10 +85,18 @@ public class FenceGateBlock extends Block implements IPaintable
     }
 
     @Override
-    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
-    	int directionmeta = mob.getHorizontalPlacementDirection(side).getHorizontalIndex();
-        int colormeta = world.getBlockMetadata(x, y, z);
-        world.setBlockMetadataWithNotify(x, y, z, directionmeta | (colormeta & 0xF0));
+    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double xPlaced, double yPlaced) {
+    	int direction = mob.getHorizontalPlacementDirection(side).getHorizontalIndex();
+        int meta = world.getBlockMetadata(x, y, z);
+        world.setBlockMetadataWithNotify(x, y, z, direction | (meta & ~MASK_DIRECTION));
+    }
+
+    @Override
+    public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
+        if (!side.isHorizontal()) side = Side.NORTH;
+        int direction = side.getDirection().getHorizontalIndex();
+        int meta = world.getBlockMetadata(x, y, z);
+        world.setBlockMetadataWithNotify(x, y, z, direction | (meta & ~MASK_DIRECTION));
     }
     
     @Override
@@ -100,23 +110,23 @@ public class FenceGateBlock extends Block implements IPaintable
     public boolean onBlockRightClicked(World world, int x, int y, int z, @Nullable Player player, Side side, double xPlaced, double yPlaced)
     {
         int l = world.getBlockMetadata(x, y, z);
-        if(func_35291_d(l))
+        if(isOpen(l))
         {
-            world.setBlockMetadataWithNotify(x, y, z, l & -5);
+            world.setBlockMetadataWithNotify(x, y, z, l & ~MASK_OPEN);
         } else
         {
             int i1 = 0;
             if (player != null) {
                 i1 = (MathHelper.floor((double)((player.yRot * 4F) / 360F) + 0.5D) & 3) % 4;
             }
-            int j1 = func_35290_f(l);
+            int j1 = getDirection(l);
             if(j1 == (i1 + 2) % 4)
             {
                 l = (l & 0xF0) | i1;
             }
-            world.setBlockMetadataWithNotify(x, y, z, l | 4);
+            world.setBlockMetadataWithNotify(x, y, z, l | MASK_OPEN);
         }
-        if(java.lang.Math.random() < 0.5D)
+        if(Math.random() < 0.5D)
         {
             world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, x, y, z, "random.door_open", 1.0F, 1.0F);
         } else
@@ -131,14 +141,14 @@ public class FenceGateBlock extends Block implements IPaintable
         onBlockRightClicked(world, x, y, z, null, direction.getSide(), 0.5, 0.5);
     }
 
-    public static boolean func_35291_d(int i)
+    public static boolean isOpen(int meta)
     {
-        return (i & 4) != 0;
+        return (meta & MASK_OPEN) != 0;
     }
 
-    public static int func_35290_f(int i)
+    public static int getDirection(int meta)
     {
-        return i & 3;
+        return meta & MASK_DIRECTION;
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/block/FireflyLanternBlock.java b/src/main/java/net/minecraft/core/block/FireflyLanternBlock.java
index 5e3ed709d..5a51483d1 100644
--- a/src/main/java/net/minecraft/core/block/FireflyLanternBlock.java
+++ b/src/main/java/net/minecraft/core/block/FireflyLanternBlock.java
@@ -19,7 +19,8 @@ import java.util.Random;
 import java.util.function.Supplier;
 
 public class FireflyLanternBlock extends Block{
-
+    public static final int MASK_HANGING = 0b0000_0001;
+    public static final int MASK_ANGLED = 0b0000_0010;
     private final Supplier<Item> itemSupplier;
     private final FireflyClusterMob.FireflyColor color;
 
@@ -35,7 +36,7 @@ public class FireflyLanternBlock extends Block{
     {
         int metadata = world.getBlockMetadata(x, y, z);
         float offset = 0.0F;
-        if (metadata == 1)
+        if ((metadata & MASK_HANGING) != 0)
             offset = 0.3875F;
         return AABB.getTemporaryBB(x + 0.3125f, y + offset, z + 0.3125f, x + 1 - 0.3125f, (float) y + 0.5F + offset, z + 1 - 0.3125f);
     }
@@ -92,18 +93,18 @@ public class FireflyLanternBlock extends Block{
         return true;
     }
     @Override
-    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
-        if ((side == Side.BOTTOM || (side != Side.TOP && sideHeight >= 0.5d)) && (world.isBlockNormalCube(x, y+1, z) || Block.hasTag(world.getBlockId(x, y + 1, z), BlockTags.CAN_HANG_OFF))){
-            world.setBlockMetadataWithNotify(x, y, z, 1);
+    public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
+        if ((side == Side.BOTTOM || (side != Side.TOP && yPlaced >= 0.5d)) && (world.isBlockNormalCube(x, y+1, z) || Block.hasTag(world.getBlockId(x, y + 1, z), BlockTags.CAN_HANG_OFF))){
+            world.setBlockMetadataWithNotify(x, y, z, MASK_HANGING);
             return;
         }
-        if ((side == Side.TOP || (side != Side.BOTTOM && sideHeight < 0.5d)) && (world.canPlaceOnSurfaceOfBlock(x, y-1, z))){
+        if ((side == Side.TOP || (side != Side.BOTTOM && yPlaced < 0.5d)) && (world.canPlaceOnSurfaceOfBlock(x, y-1, z))){
             world.setBlockMetadataWithNotify(x, y, z, 0);
             return;
         }
         if(world.isBlockNormalCube(x, y+1, z) || Block.hasTag(world.getBlockId(x, y + 1, z), BlockTags.CAN_HANG_OFF))
         {
-            world.setBlockMetadataWithNotify(x, y, z, 1);
+            world.setBlockMetadataWithNotify(x, y, z, MASK_HANGING);
         } else world.setBlockMetadataWithNotify(x, y, z, 0);
     }
 
@@ -145,7 +146,7 @@ public class FireflyLanternBlock extends Block{
     public boolean canBlockStay(World world, int x, int y, int z)
     {
         int meta = world.getBlockMetadata(x, y, z);
-        if(meta == 1) {
+        if((meta & MASK_HANGING) != 0) {
             return world.isBlockNormalCube(x, y + 1, z) || Block.hasTag(world.getBlockId(x, y + 1, z), BlockTags.CAN_HANG_OFF);
         }
 
diff --git a/src/main/java/net/minecraft/core/block/FloweringCherryLeavesBlock.java b/src/main/java/net/minecraft/core/block/FloweringCherryLeavesBlock.java
index 1f0d820a3..7ab65c9c3 100644
--- a/src/main/java/net/minecraft/core/block/FloweringCherryLeavesBlock.java
+++ b/src/main/java/net/minecraft/core/block/FloweringCherryLeavesBlock.java
@@ -18,6 +18,7 @@ import java.util.Random;
 public class FloweringCherryLeavesBlock extends CherryLeavesBlock implements IBonemealable
 {
     public static final int MASK_GROWTH_DATA = 0b1111_0000;
+    public static final int MAX_GROWTH_STATE = 1;
 	public FloweringCherryLeavesBlock(String key, String namespaceId, int id) {
         super(key, namespaceId, id);
     }
@@ -49,16 +50,17 @@ public class FloweringCherryLeavesBlock extends CherryLeavesBlock implements IBo
 
     public boolean harvest(World world, int x, int y, int z, @Nullable Player player) {
         int meta = world.getBlockMetadata(x, y, z);
-        int decayData = meta & MASK_DECAY_DATA;
         int growthRate = getGrowthRate(meta);
         if(growthRate > 0)
         {
-            world.playSoundAtEntity(player, player, "random.pop", 0.2F, 0.5f);
+            if (player != null) {
+                world.playSoundAtEntity(player, player, "random.pop", 0.2F, 0.5f);
+            }
             if(!world.isClientSide)
             {
                 dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, meta, null, null);
             }
-            world.setBlockMetadataWithNotify(x, y, z, decayData);
+            world.setBlockMetadataWithNotify(x, y, z, setGrowthRate(meta, 0));
             world.scheduleBlockUpdate(x, y, z, Blocks.LEAVES_CHERRY_FLOWERING.id, tickDelay());
             return true;
         }
@@ -79,7 +81,7 @@ public class FloweringCherryLeavesBlock extends CherryLeavesBlock implements IBo
         if (world.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_SPRING) {
             if (rand.nextInt(20) == 0) {
                 if ((growthRate) == 0) {
-                    world.setBlockMetadataWithNotify(x, y, z, 1 << 4 | meta);
+                    world.setBlockMetadataWithNotify(x, y, z, setGrowthRate(meta, MAX_GROWTH_STATE));
                     world.scheduleBlockUpdate(x, y, z, Blocks.LEAVES_CHERRY_FLOWERING.id, tickDelay());
                 }
             }
@@ -93,13 +95,13 @@ public class FloweringCherryLeavesBlock extends CherryLeavesBlock implements IBo
     @Override
     public boolean onBonemealUsed(ItemStack itemstack, @Nullable Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
         int meta = world.getBlockMetadata(blockX, blockY, blockZ);
-        if(((meta & 0xF0) >> 4) == 0)
+        if(getGrowthRate(meta) == 0)
         {
             if(!world.isClientSide)
             {
                 if(world.getSeasonManager().getCurrentSeason() != Seasons.OVERWORLD_SPRING)
                     return true;
-                world.setBlockMetadataWithNotify(blockX, blockY, blockZ, (1 << 4) | meta);
+                world.setBlockMetadataWithNotify(blockX, blockY, blockZ, setGrowthRate(meta, MAX_GROWTH_STATE));
                 if (player == null || player.getGamemode().consumeBlocks())
                 {
                     itemstack.stackSize--;
@@ -110,6 +112,10 @@ public class FloweringCherryLeavesBlock extends CherryLeavesBlock implements IBo
         return false;
     }
     public static int getGrowthRate(int meta){
-        return (meta & MASK_GROWTH_DATA) >> NUM_DECAY_BITS;
+        return (meta & MASK_GROWTH_DATA) >> 4;
+    }
+
+    public static int setGrowthRate(int meta, int growthRate) {
+        return (meta & ~MASK_GROWTH_DATA) | (growthRate << 4) & MASK_GROWTH_DATA;
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/FlowingFluidBlock.java b/src/main/java/net/minecraft/core/block/FlowingFluidBlock.java
index 4a64f6b57..0a720d358 100644
--- a/src/main/java/net/minecraft/core/block/FlowingFluidBlock.java
+++ b/src/main/java/net/minecraft/core/block/FlowingFluidBlock.java
@@ -147,22 +147,22 @@ public class FlowingFluidBlock extends FluidBlock
         }
     }
 
-    private void flowIntoBlock(World world, int i, int j, int k, int l)
+    private void flowIntoBlock(World world, int x, int y, int z, int meta)
     {
-        if(canSpreadTo(world, i, j, k))
+        if(canSpreadTo(world, x, y, z))
         {
-            int i1 = world.getBlockId(i, j, k);
+            int i1 = world.getBlockId(x, y, z);
             if(i1 > 0)
             {
                 if(blockMaterial == Material.lava)
                 {
-                    fizz(world, i, j, k);
+                    fizz(world, x, y, z);
                 } else
                 {
-                    Block.blocksList[i1].dropBlockWithCause(world, EnumDropCause.WORLD, i, j, k, world.getBlockMetadata(i, j, k), null, null);
+                    Block.blocksList[i1].dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
                 }
             }
-            world.setBlockAndMetadataWithNotify(i, j, k, id, l);
+            world.setBlockAndMetadataWithNotify(x, y, z, id, meta);
         }
     }
 
@@ -295,9 +295,9 @@ public class FlowingFluidBlock extends FluidBlock
         return currentFlowDecay >= 0 && flowDecay >= currentFlowDecay ? currentFlowDecay : flowDecay;
     }
 
-    private boolean canSpreadTo(World world, int i, int j, int k)
+    private boolean canSpreadTo(World world, int x, int y, int z)
     {
-        Material material = world.getBlockMaterial(i, j, k);
+        Material material = world.getBlockMaterial(x, y, z);
         if(material == blockMaterial)
         {
             return false;
@@ -308,7 +308,7 @@ public class FlowingFluidBlock extends FluidBlock
         }
         else
         {
-            return !isFluidBlocking(world, i, j, k);
+            return !isFluidBlocking(world, x, y, z);
         }
     }
 
diff --git a/src/main/java/net/minecraft/core/block/FullRotatableBlock.java b/src/main/java/net/minecraft/core/block/FullRotatableBlock.java
index c4cb103b9..5d3947869 100644
--- a/src/main/java/net/minecraft/core/block/FullRotatableBlock.java
+++ b/src/main/java/net/minecraft/core/block/FullRotatableBlock.java
@@ -5,6 +5,7 @@ import net.minecraft.core.entity.Mob;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
 import org.jetbrains.annotations.NotNull;
 
 public abstract class FullRotatableBlock extends Block {
@@ -14,12 +15,19 @@ public abstract class FullRotatableBlock extends Block {
     }
 
     @Override
-    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
+    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double xPlaced, double yPlaced) {
         final Direction direction = mob.getPlacementDirection(side).getOpposite();
 
         world.setBlockMetadataWithNotify(x, y, z, directionToMeta(direction));
     }
 
+    @Override
+    public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
+        final Direction direction = side.getOpposite().getDirection();
+
+        world.setBlockMetadataWithNotify(x, y, z, directionToMeta(direction));
+    }
+
     public static int directionToMeta(Direction direction) {
         return direction.getId() & MASK_DIRECTION;
     }
@@ -27,4 +35,11 @@ public abstract class FullRotatableBlock extends Block {
     public static Direction metaToDirection(int meta) {
         return Direction.getDirectionById(meta & MASK_DIRECTION);
     }
+
+    @Override
+    public void onBlockPlacedByActivator(World world, int x, int y, int z, ActivatorBlockEntity activator, Direction direction)
+    {
+        super.onBlockPlacedByActivator(world, x, y, z, activator, direction);
+        world.setBlockMetadataWithNotify(x, y, z, RotatableBlock.setDirection(0, direction));
+    }
 }
diff --git a/src/main/java/net/minecraft/core/block/FurnaceBlock.java b/src/main/java/net/minecraft/core/block/FurnaceBlock.java
index a08e5aeeb..3a4f3b836 100644
--- a/src/main/java/net/minecraft/core/block/FurnaceBlock.java
+++ b/src/main/java/net/minecraft/core/block/FurnaceBlock.java
@@ -31,13 +31,6 @@ public class FurnaceBlock extends RotatableEntityBlock
         isActive = flag;
     }
 
-    @Override
-	public void onBlockPlacedByWorld(World world, int x, int y, int z)
-    {
-        super.onBlockPlacedByWorld(world, x, y, z);
-        setDefaultDirection(world, x, y, z);
-    }
-
     @Override
     public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
     {
diff --git a/src/main/java/net/minecraft/core/block/IceBlock.java b/src/main/java/net/minecraft/core/block/IceBlock.java
index fb8e4de98..0feddf8a8 100644
--- a/src/main/java/net/minecraft/core/block/IceBlock.java
+++ b/src/main/java/net/minecraft/core/block/IceBlock.java
@@ -44,13 +44,13 @@ public class IceBlock extends TransparentBlock
     }
 
     @Override
-    public void harvestBlock(World world, Player entityplayer, int i, int j, int k, int meta, BlockEntity blockEntity)
+    public void harvestBlock(World world, Player entityplayer, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
-        super.harvestBlock(world, entityplayer, i, j, k, meta, blockEntity);
-        Material material = world.getBlockMaterial(i, j - 1, k);
+        super.harvestBlock(world, entityplayer, x, y, z, meta, blockEntity);
+        Material material = world.getBlockMaterial(x, y - 1, z);
         if(material.blocksMotion() || material.isLiquid())
         {
-            world.setBlockWithNotify(i, j, k, Blocks.FLUID_WATER_FLOWING.id);
+            world.setBlockWithNotify(x, y, z, Blocks.FLUID_WATER_FLOWING.id);
         }
     }
 
@@ -66,6 +66,6 @@ public class IceBlock extends TransparentBlock
     @Override
     public int getPistonPushReaction(World world, int x, int y, int z)
     {
-        return 0;
+        return Material.PISTON_PUSHABLE;
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/JukeboxBlock.java b/src/main/java/net/minecraft/core/block/JukeboxBlock.java
index 7dac2e605..48e354516 100644
--- a/src/main/java/net/minecraft/core/block/JukeboxBlock.java
+++ b/src/main/java/net/minecraft/core/block/JukeboxBlock.java
@@ -53,14 +53,14 @@ public class JukeboxBlock extends EntityBlock
         }
     }
 
-    public void ejectRecord(World world, int i, int j, int k)
+    public void ejectRecord(World world, int x, int y, int z)
     {
         if(world.isClientSide)
         {
             return;
         }
-        BlockEntity blockEntity = world.getBlockEntity(i, j, k);
-        blockEntity.dropContents(world, i, j, k);
+        BlockEntity blockEntity = world.getBlockEntity(x, y, z);
+        blockEntity.dropContents(world, x, y, z);
     }
 
     @Override
